/**
 * the sydnication tool works by downloading the list of updated sites.
 * passing it through the filter with bookmarks
 * the filter then generate an rdf source
 * the html is then generated from the rdf
 */

include('chrome://jslib/content/io/io.js');

var syndPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
syndPref = syndPref.getBranch(null);

var du = new DirUtils();
var userDir = du.getMozUserHomeDir();
var chromeDir = du.getChromeDir();
var fu = new FileUtils();
var fullPath = fu.append(userDir, "syndicationTmp.html");
var rdfFullPath  = fu.append(userDir, "syndicationTmp.rdf");
var rdfFh = new File(rdfFullPath);
var ioService = Components.classes["@mozilla.org/network/io-service;1"]
						  .getService(Components.interfaces.nsIIOService);
var localRdfUrl = ioService.newFileURI(rdfFh.nsIFile);
var fh = new File(fullPath);

var userTime = 0;

var RDFContainerUtils = Components.classes["@mozilla.org/rdf/container-utils;1"]
								  .getService(Components.interfaces.nsIRDFContainerUtils);

var RDFContainer = Components.classes["@mozilla.org/rdf/container;1"]
							 .getService(Components.interfaces.nsIRDFContainer);


var RDF = Components.classes['@mozilla.org/rdf/rdf-service;1'].getService();
RDF = RDF.QueryInterface(Components.interfaces.nsIRDFService);

var SyndNamespace = RDF.GetResource('http://www.exitspace.net/syndication', true);
var localSource = RDF.GetDataSource(localRdfUrl.spec);	  // local rdf handle
var remoteSource = null;
var localRDS = null;
var newRdfListing = null;

var sepFound;
var sepIndex;

var MAXCOUNT;

init();

function init()
{
  if (fu.exists(fullPath)) {
	fh = new File(fullPath);
	fh.open();
	var regex = /<!--(\d+)-->/gi;
	var fileContent = fh.readline();
	regex.exec(fileContent);
	fh.close();
	userTime = parseInt(RegExp.$1);
  } else {
	userTime = 0;
  }
}

/**
 * get the updated list and output it to a html file
 */
function updateRdf()
{
  getUpdateList();
}

/**
 * generate a html output from rdf
 */
function genOutput()
{
  var thisresult = "";
  var RDFLocalContainer = Components.classes["@mozilla.org/rdf/container;1"]
								  .getService(Components.interfaces.nsIRDFContainer);
  RDFLocalContainer.Init(localSource, SyndNamespace);
  var result = RDFLocalContainer.GetElements();
  syndContent = "<!--" + newRdfListing[0] + "-->\n";
  syndContent += "<font size='-2'><ul style='margin-left: -4em;overflow: hidden'>";
  try {
	  MAXCOUNT = syndPref.getIntPref("syndication.maxNumEntry");
  } catch (e) {
	  MAXCOUNT = 20;
  }
  if (RDFLocalContainer.GetCount() < MAXCOUNT) {
	  listCount = RDFLocalContainer.GetCount();
  } else {
	  listCount = MAXCOUNT;
  }
  for (count = 0; count < listCount; count++) {
	thisresult = result.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
	if (count == sepIndex - 1) {
	  if (sepFound == true) {
		var myTime = new Date(parseInt(newRdfListing[0]) * 1000);
//		  syndContent += "<li>" + myTime.toGMTString() + "</li>";
		syndContent += "<li>----</li>";
	  }
	}
	syndContent += "<li><a href='" + thisresult.Value + "' target='window.frames[2]'>" + thisresult.Value + "</a></li>";
  }
  syndContent += "</ul></font>";
  if (!fh.exists()) {
	  fh.create();
  }
  fh.open('w');
  fh.write(syndContent);
  fh.close();
}

/**
 * writeLocalRdf() update the localfeed list by inserting and deleting outdated posts
 */
function writeLocalRdf(newRdfList)
{
	var RDFLocalContainer = Components.classes["@mozilla.org/rdf/container;1"]
									  .getService(Components.interfaces.nsIRDFContainer);
	var sydnicatedUrl = "";
	if (!RDFContainerUtils.IsContainer(localSource, SyndNamespace)) {
	  RDFContainerUtils.MakeSeq(localSource, SyndNamespace);
	}
	RDFLocalContainer.Init(localSource, SyndNamespace);
	result = RDFLocalContainer.GetElements();
	dump("length: " + newRdfList.length + "\n");
	var rdfCount = RDFLocalContainer.GetCount()
/*	  if (RDFLocalContainer.GetCount() > 5) {
		alert ("boo");
	}*/
	sepFound = false;
	for (i = 1; i < newRdfList.length; i++) {
		sydnicatedUrl = RDF.GetResource(newRdfList[i]);
		if (sepFound == false) {
		  sepIndex = RDFContainer.IndexOf(sydnicatedUrl);
		  if (sepIndex != -1) {
			  sepFound = true;
		  }
		}
		RDFLocalContainer.RemoveElement(sydnicatedUrl, true);
		if (rdfCount != 0) {
		  RDFLocalContainer.InsertElementAt(sydnicatedUrl, i, true);
		} else {
		  RDFLocalContainer.AppendElement(sydnicatedUrl, true);
		}

	}

//	  var homepage = RDF.GetResource('http://people.netscape.com/waterson');
//	  var LastUpdate = RDF.GetResource('urn:my-web-vocabulary:lastUpdate');
//	  var value = RDF.GetLiteral(newRdfList[0]);
//	  localSource.Assert(SyndNamespace, LastUpdate, value, true);

	localRDS.Flush();
}

function populateLocalFeed(newRdfList)
{
  newRdfListing = newRdfList;
  if (!rdfFh.exists()) {	// create empty template
	  rdfFh.open('w');
	  rdfFh.write('<?xml version="1.0"?>\n<RDF:RDF xmlns:RDF=' +
				  '"http://www.w3.org/1999/02/22-rdf-syntax-ns#">\n</RDF:RDF>\n');
	  rdfFh.close();
  }
  localRDS = localSource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
  if (localRDS.loaded) {
	  localRDS.Refresh(false);
	  dump("the datasource " + rdfFullPath + " was already loaded!\n");
  } else {
	  dump("the datasource " + rdfFullPath + " wasn't loaded, but it's loading now!\n");
  }
	  // RDF/XML Datasources are all nsIRDFXMLSinks
	  var localSink = localSource.QueryInterface(Components.interfaces.nsIRDFXMLSink);
	  // Attach the observer to the datasource-as-sink
	  localSink.addXMLSinkObserver(ObserverLocalRDF);
}

var ObserverLocalRDF = {
  onBeginLoad: function(aSink) {},
  onInterrupt: function(aSink) {},
  onResume: function(aSink) {},
  onEndLoad: function(aSink) {
	writeLocalRdf(newRdfListing);
	genOutput();
	loadDisplay();
	document.getElementById("statusbar-display").label = "Data source loaded";
	  // RDF/XML Datasources are all nsIRDFXMLSinks
	  var localSink = localSource.QueryInterface(Components.interfaces.nsIRDFXMLSink);
	  // Attach the observer to the datasource-as-sink
	  localSink.removeXMLSinkObserver(ObserverLocalRDF);
  },
  onError: function(aSink, aStatus, aErrorMsg) { alert("error! " + aErrorMsg); }
};

/**
 * observer for loading rdf datasource
 */
var ObserverRemoteRDF = {
  onBeginLoad: function(aSink) {},
  onInterrupt: function(aSink) {},
  onResume: function(aSink) {},
  onEndLoad: function(aSink) {
//	  updateList = getDetails(localSource);
	updateList = getDetails(remoteSource); // return bookmark list
	populateLocalFeed(updateList);		   //
	  // RDF/XML Datasources are all nsIRDFXMLSinks
	  var remoteSink = localSource.QueryInterface(Components.interfaces.nsIRDFXMLSink);
	  // Attach the observer to the datasource-as-sink
	  remoteSink.removeXMLSinkObserver(ObserverRemoteRDF);

  },
  onError: function(aSink, aStatus, aErrorMsg) { dump("error! " + aErrorMsg); }
};

/**
 * the notifcation system for updating the list
 */
function getUpdateList()
{
  dump("Get source prior to: " + userTime);
  var rdfUrl = "http://www.exitspace.net/utils/syndication/weblogs.php?userTime=" + userTime;
  remoteSource = RDF.GetDataSource(rdfUrl);
  var remote = remoteSource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
  var updateList = "";
//	var remoteSource = RDF.GetDataSource("file:///f:/output.rdf");
  if (remote.loaded) {
	dump("the datasource " + rdfUrl + " was already loaded!\n");
	document.getElementById("statusbar-display").label = "Refreshing data source";
	remote.Refresh(false);
	document.getElementById("statusbar-display").label = "Data source loaded";
  } else {
	dump("the datasource " + rdfUrl + " wasn't loaded, but it's loading now!\n");
	document.getElementById("statusbar-display").label = "Loading data source";
  }
	// RDF/XML Datasources are all nsIRDFXMLSinks
	var sink = remoteSource.QueryInterface(Components.interfaces.nsIRDFXMLSink);
	// Attach the observer to the datasource-as-sink
	sink.addXMLSinkObserver(ObserverRemoteRDF);
//	return updateList;
}

/**
 * get the list and extract the urls
 */
function getDetails(remoteSource)
{
  var list = new Array();
  var aCount = 0;
  RDFContainer.Init(remoteSource, RDF.GetResource('http://www.weblogs.com/', true));
//	RDFContainer.Init(remoteSource, RDF.GetResource('http://www.exitspace.net/syndication', true));
  result = RDFContainer.GetElements();
  for (count = 0; count < RDFContainer.GetCount(); count++) {
	thisresult = result.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
	if (count == 0) {
	  var regex = /http:\/\/.+\//gi;
	  tempTime = thisresult.Value.replace(regex, "");
	  userTime = parseInt(tempTime);
	  dump("New source timestamp: " + userTime);
	  list[aCount] = userTime;
	  aCount++;
	}
	bookmark = matchBookmark(thisresult.Value);
	if (bookmark) {
	  list[aCount] = bookmark;
	  aCount++;
	}
//		  arcCursor = result.ArcLabelsOut(thisresult);
  }
  return list;
}

/**
 * find the urls that are also in the bookmarks
 */
function matchBookmark(bookmarkUrl)
{
  var ds = RDF.GetDataSource("rdf:bookmarks");
  rdfnode = ds.GetTarget(RDF.GetResource(bookmarkUrl), RDF.GetResource('http://home.netscape.com/NC-rdf#URL'), true);
  if (rdfnode) {
	urlValue = rdfnode.QueryInterface(Components.interfaces.nsIRDFLiteral);
	return urlValue.Value;
  }
  return null;
}

/** scrapt codes
 *
   var homepage = RDF.GetResource('http://www.google.com/');
   var FV_quality = RDF.GetResource('urn:my-web-vocabulary:quality');
   var value = RDF.GetLiteral('tres cool');
**/

/** creating rdf
 *
   var homepage = RDF.GetResource('http://people.netscape.com/waterson');
   var FV_quality = RDF.GetResource('urn:my-web-vocabulary:quality');
   var value = RDF.GetLiteral('tres cool');
   RDFContainer.AppendElement(FV_quality);
   localSource.Assert(homepage, FV_quality, value, true);
   localRDS.Flush();
*/

/** iterate through the remote data source
 *
  var RDFContainer = Components.classes["@mozilla.org/rdf/container;1"].getService(Components.interfaces.nsIRDFContainer);
  RDFContainer.Init(ds, RDF.GetResource('http://www.weblogs.com/', true));
  alert (RDFContainer.GetCount());
  var result = ds.GetAllResources();//IsBookmarked("http://www.google.com");
  for (count = 0; count < 4; count++) {
	alert (result.hasMoreElements());
	thisresult = result.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
	alert (thisresult.Value);
	arcCursor = result.ArcLabelsOut(thisresult);
  }
**/


/** match the bookmarks
 *
  rdfnode = ds.GetTarget(RDF.GetResource('http://www.alltheweb.com/'), RDF.GetResource('http://home.netscape.com/NC-rdf#URL'), true);
  // do a while loop to loop all cases, so its.. (auto resource), (url), (the value we want to check)
  value = rdfnode.QueryInterface(Components.interfaces.nsIRDFLiteral);
  alert(value);
  alert('target is ' + value.Value + '!');
**/

/** loop datasource
 *
  while (result.hasMoreElements()) {
	thisResult = result.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
	dump (result + " " + thisResult.Value);
	if (ds.HasAssertion(thisResult,
	  RDF.GetResource('http://home.netscape.com/NC-rdf#URL'),
	  RDF.GetResource('http://joehewitt.com/'),
	  true)) {
		dump("wohoo");
	}
  }
**/


