#weblogs.com provided a "what's new" stream for websites. In fact it's a weblog on weblog/sites,
# since it take note of 'interesting' new sites/stories. The problem right now is it's designed for humans,
# and only for short burst of time. Since it point to the actual website instead of a computer parseble feed,
# it also doesn't point to the perm link.
#
# To make use of this syndication service, we first have to download the listing. This should include:
# updated urls, timestamp

#!/usr/bin/perl

use lib "/usr/local/plesk/apache/vhosts/exitspace.net/httpdocs/modules";

use strict;
#use warnings;
use LWP::Simple;
use CGI;
use Time::Local;


my %monthHash = ('Jan' => 0, 'Feb' => 1, 'Mar' => 2, 'Apr' => 3,
                 'May' => 4, 'Jun' => 5, 'Jul' => 6, 'Aug' => 7,
                 'Sep' => 8, 'Oct' => 9, 'Nov' => 10, 'Dec' => 11);


my $cgi = new CGI;
#print $cgi->header();
print "Content-Type: text/rdf; charset=ISO-8859-1";

#my $url = 'http://www.weblogs.com/changes.xml';
#my $content = get('http://www.weblogs.com/changes.xml');
my $content = get('http://www.weblogs.com/changes.xml');
my $line;
my $name;
my $url;
my $timestamp;

my @lines = split(/\n/, $content);
print '<?xml version="1.0"?>' . "\n";
print '<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"' . "\n";
print "\t" . 'xmlns="http://www.exitspace.net/weblogs"' . "\n";
print "\t" . 'xmlns:rss="http://purl.org/rss/1.0/">' . "\n";
print '<rdf:Seq about="http://www.weblogs.com/">' . "\n";
foreach $line (@lines) {
    if ($line =~ m/<weblog name="(.+)" url="(.+)" when="(\d+)".*>/) {
        print "\t" . '<rdf:li resource="' . $2 . '" timestamp="' . ($timestamp - $3) . '"/>' . "\n";
#        print "\t<title>$1</title>\n";
#        print "</updated>\n";
    } elsif ($line =~ m/<weblogUpdates version="(\d)" updated=".+, (\d+) (\w+) (\d+) (\d.):(\d.):(\d.) GMT" count="\d+">/) {
        my $month = $monthHash{$3};
        $timestamp = timegm($7, $6, $5, $2, $month, $4);
    }
}
print $timestamp . ":" . localtime() . ":" .localtime($timestamp);
print "</rdf:Seq>\n</rdf:RDF>";
#    $name = /name=".+"/;
#    $url = /url=".+"/;
#    print "$name\t$url";
#     print $line;

#print "</html></body>";
sub atoi {
  my $t;
  foreach my $d (split(//, shift())) {
    $t = $t * 10 + $d;
  }
}


