var RDFC = '@mozilla.org/rdf/container;1';
RDFC = Components.classes[RDFC].getService();
RDFC = RDFC.QueryInterface(Components.interfaces.nsIRDFContainer);

var RDFCUtils = '@mozilla.org/rdf/container-utils;1';
RDFCUtils = Components.classes[RDFCUtils].getService();
RDFCUtils = RDFCUtils.QueryInterface(Components.interfaces.nsIRDFContainerUtils);

var RDF = "@mozilla.org/rdf/rdf-service;1";
RDF = Components.classes[RDF].getService();
RDF = RDF.QueryInterface(Components.interfaces.nsIRDFService);

var XPIMAKER_URI="http://www.xulplanet.com/rdf/xpimaker#";
var MOZILLA_RDF_URI="http://www.mozilla.org/rdf/chrome#";

var gDataSource=null;
var gAppInfo=null;
var gAppType="content";
var gAppDirty=false;
var gAppNewFile=true;
var gAppTitle=null;
var gLoadedSources={};

function getDataSource()
{
  // *** test this
  if (gDataSource==null){
    gDataSource=new RDFDataSource();
  }
  return gDataSource;
}

// *** this function is needed because newer builds of Mozilla don't let you use
// *** empty RDF files.
function createEmptyRDFFile(dir,file)
{
  var aDestFile=Components.classes["@mozilla.org/file/local;1"].createInstance();
  aDestFile=aDestFile.QueryInterface(Components.interfaces.nsILocalFile);
  aDestFile.initWithPath(dir);
  if (file!=null) aDestFile.append(file);

  if (aDestFile.exists()){
    aDestFile.remove(false);
  }

  var outstr="<?xml version='1.0'?>\n<RDF:RDF xmlns:RDF='http://www.w3.org/1999/02/22-rdf-syntax-ns#'></RDF:RDF>\n";
  var fileio=Components.classes["@mozilla.org/network/file-io;1"].createInstance();
  fileio=fileio.QueryInterface(Components.interfaces.nsIFileIO);
  fileio.init(aDestFile,-1,438);

  var ostr=fileio.outputStream;
  ostr.write(outstr,outstr.length);
  ostr.close();

  return aDestFile.URL;

/*
  var aDestURL=Components.classes["@mozilla.org/network/standard-url;1"].createInstance();
  aDestURL=aDestURL.QueryInterface(Components.interfaces.nsIFileURL);
  aDestURL.file=aDestFile;

  return aDestURL.spec;
*/
}

function fileToURL(path,file)
{
  var aDestFile=Components.classes["@mozilla.org/file/local;1"].createInstance();
  aDestFile=aDestFile.QueryInterface(Components.interfaces.nsILocalFile);
  aDestFile.initWithPath(path);
  if (file!=null) aDestFile.append(file);

  return aDestFile.URL;

/*
  var aDestURL=Components.classes["@mozilla.org/network/standard-url;1"].createInstance();
  aDestURL=aDestURL.QueryInterface(Components.interfaces.nsIFileURL);
  aDestURL.file=aDestFile;

  return aDestURL.spec;
*/
}

function URLToFile(url)
{
  var aDestURL=Components.classes["@mozilla.org/network/standard-url;1"].createInstance();
  aDestURL=aDestURL.QueryInterface(Components.interfaces.nsIFileURL);
  aDestURL.spec=url;

  return aDestURL.file.path;
}

/* makeDir
 *   creates a new directory.
 *     parent - the parent directory as a nsIFile. This argument may be null, in which
 *              case the second argument should be an absolute path
 *     newdir - the new directory to create
 *     recreate - if true, the directory is deleted first
 */
function makeDir(parent,newdir,recreate)
{
  if (parent!=null){
    var parentclone=parent.clone();
    parentclone.append(newdir);
    parent=parentclone;
  }
  else {
    parent=Components.classes["@mozilla.org/file/local;1"].createInstance();
    parent=parent.QueryInterface(Components.interfaces.nsILocalFile);
    parent.initWithPath(newdir);
  }
  if (parent.exists()){
    if (recreate){
      parent.remove(true);
    }
  }
  else {
    parent.create(parent.DIRECTORY_TYPE,511);
  }

  return parent;
}

var dropFileOverObserver = {
  getSupportedFlavours : function ()
  {
    var flavours = new FlavourSet();
    flavours.appendFlavour("application/x-moz-url");
    flavours.appendFlavour("text/unicode");
    flavours.appendFlavour("application/x-moz-file","nsIFile");
    return flavours;
  },
  onDragOver: function (evt,flavour,sess){},
  onDrop: function (evt,dropdata,sess)
  {
    var target=evt.target;
    while (target.tagName!="tree"){
      target=target.parentNode;
    }
    if (target==null) return;
    var type=target.getAttribute("type");

    var fl=dropdata.data;
    if (typeof fl!="string"){
      addFileNode("urn:xpimaker:packlist",type,fl.path);
      return;
    }
    fl=""+fl;
    var flarr=fl.split("\n");
    for (var t=0;t<flarr.length;t++){
      flarr[t]=flarr[t].replace(/^\s*/,"");
      flarr[t]=flarr[t].replace(/\s*$/,"");
      if (flarr[t].length>0){
        fl=URLToFile(flarr[t]);
        addFileNode("urn:xpimaker:packlist",type,fl);
      }
    }
  }
};

